<script lang="ts">
  import { Popover, Tooltip } from '@sveltestrap/sveltestrap';
  import Fa from 'svelte-fa';
  import {
    faArrowCircleDown,
    faArrowCircleUp,
    faCircleExclamation,
    faCircleQuestion,
    faHourglassStart,
  } from '@fortawesome/free-solid-svg-icons';
  import { isEmpty } from '@utils/index';
  import type { ScoreBoardAdversarialStatus } from '@models/Adversarial';
  import type { ScoreBoardServiceStatus } from '@models/Service';

  export let displayName = false;
  export let size = '2x';
  export let status: ScoreBoardAdversarialStatus | ScoreBoardServiceStatus;
  let uid = `uid_${Math.floor(Math.random() * Math.floor(Math.random() * Date.now()))}`;

  let statusIcon: HTMLSpanElement;

  function b64decode(s: string): string {
    try {
      return atob(s).replace(/\\n/g, '\n');
    } catch {
      return s;
    }
  }

  function getDetails(): string | null {
    if (!isEmpty(status.participant?.detailed_results)) {
      console.log('returning parsed json');
      return JSON.stringify(status.participant?.detailed_results, null, 2);
    }

    const stderr = status.data?.exec?.stderr;
    const stdout = status.data?.exec?.stderr;
    if (status.result_code === 'error' && !!stderr) return b64decode(stderr);
    if (status.result_code === 'error' && !!stdout) return b64decode(stdout);

    return null;
  }
</script>

{#await getDetails() then details}
  {#if details}
    <Popover class="ms-2" container="body" placement="top" target={uid}>
      {#if displayName}
        <p><b>{status.check.display_name}</b></p>
      {/if}
      <pre style="max-height: 50vh;">{details}</pre>
    </Popover>
  {/if}
  <a bind:this={statusIcon} id={uid} class="fa-stack" class:clickable={!!details} aria-hidden="true">
    {#if status.result_code === 'success'}
      <Fa {size} scale={1.3} icon={faArrowCircleUp} class="scoreboard-service-success" />
    {:else if status.result_code === 'partial'}
      <Fa {size} scale={1.3} icon={faCircleExclamation} class="scoreboard-service-partial" />
    {:else if status.result_code === 'failure'}
      <Fa {size} scale={1.3} icon={faArrowCircleDown} class="scoreboard-service-failure" />
    {:else if status.result_code === 'timeout'}
      <Fa {size} scale={1.3} icon={faArrowCircleDown} class="scoreboard-service-timeout" />
      <!-- concept for timeout display -->
      <!--    <FaLayers>-->
      <!--      <Fa size="2x" scale={1.3} icon={faArrowCircleDown} class="scoreboard-service-timeout" />-->
      <!--      <Fa size="2x" scale={0.4} translateX={0.3} translateY={-0.3} icon={faClock} class="text-dark " />-->
      <!--    </FaLayers>-->
    {:else if status.result_code === 'pending'}
      <Fa {size} scale={1.3} icon={faHourglassStart} class="scoreboard-service-unknown" />
    {:else}
      <Fa {size} scale={1.3} icon={faCircleQuestion} class="scoreboard-service-unknown" />
    {/if}
  </a>
  {#if status.participant?.feedback && status.participant?.feedback?.length > 0}
    <Tooltip target={statusIcon} placement="top">
      {#if displayName}
        <p><b>{status.check.display_name}</b></p>
      {/if}
      {@html status.participant?.feedback}
    </Tooltip>
  {/if}
{/await}
